<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####


include_once("auth.php");
include_once("defines.php");

include_once( "../include/data_source/class.ValueButtonHref.php" );
include_once( "../include/data_source/class.ValueLocale.php" );
include_once( "../include/data_source/class.SQLQuery.php" );
include_once( "../include/data_source/class.DataRowsDBValue.php" );
include_once( "../include/data_source/class.DataValue.php" );

include_once( "../include/elements/data/class.CheckDataField.php" );
include_once( "../include/elements/data/class.TextDataField.php" );
include_once( "../include/elements/data/class.PagedTableView.php" );
include_once( "../include/elements/data/class.ToolsButtons.php" );
include_once( "../include/elements/data/class.ToolsButtonData.php" );
include_once( "../include/elements/data/class.IconDataField.php" );

include_once( 'gui/module.GuiPP_HeadMenu.php' );

include_once( "../include/elements/html/class.SimpleSearchElement.php" );
include_once( "../include/elements/html/class.MainPageElement.php" );

include_once( "../include/elements/html/module.Constants.php" );

global $DEBUG;
//$DEBUG=1;


if($DEBUG){
	echo "einstellengen_ip.php: _POST:<br><pre>\n";
	print_r($_POST);
	echo "</pre><hr>\n";
}

db_connect();

if( $action == 'delete' ){
	foreach ( $ip as $ind => $ipValue ) {
		$loIpValue = new SQLString($ipValue);
		$id = safe_query2( "SELECT kunde, anbieter FROM ipadressen WHERE ip=?",$loIpValue);
		if( $id ){
			$werte = db_fetch_array( $id );
			if ( $werte['kunde'] ){
				safe_query2( "DELETE FROM ipadressen WHERE ip = ? ", $loIpValue );
				$timestamp = time();
				safe_query2( "INSERT INTO billing_del ( date, kunde, anbieter, type, item )".
										 " VALUES ( ?,'', ?,'ip',? )",
										 new SQLInteger( $timestamp ), new SQLString( $anbieter ), $loIpValue );

			} else {
				safe_query2( "DELETE FROM ipadressen WHERE ip=?", $loIpValue );
			}
			db_free_query( $id );
		}
	}
	$fehlertitel = ltext("eiiplo_errortitle");
	$fehlertext = ltext("eiiplo_error1");
}

initPagingSettings( $_POST, array( 'ip_to_search' => $ip_to_search ) );
$lcSQL = "SELECT count(ip) FROM ipadressen";
$res = db_query( $lcSQL );
list( $total_number ) = db_fetch_array( $res );
db_free_query( $res );

//Sort settings 
$listFormIndex = 0;
if( ! isset( $direction ) ) 
	$direction = 'asc';
if( ! isset( $order ) ) 
	$order = 'ip';
$lcDirIcon = ( $direction =='desc' ) ? cc_DescIcon : cc_AscIcon;
$lcNewDir =  ( $direction =='desc' ) ? 'asc' : 'desc';

switch ( $order ) {
 case 'ip':
	 $lcOrder = "  ORDER BY ip";
	 if ( $direction == 'desc' ) $lcOrder .= " DESC";
	 break;
 case 'reseller':
	 $lcOrder = " ORDER BY anbieter";
	 if ( $direction == 'desc' ) $lcOrder .= " DESC";
	 break;
 case 'user':
	 $lcOrder  = " ORDER BY kunde";
	 if ( $direction == 'desc' ) $lcOrder .= " DESC";
	 break;
 }

if( isset($ip_to_search)&&strlen($ip_to_search) ){
	$loFields = new SQLFieldSet ( new SQLField( 'ip', '%'.$ip_to_search.'%', 'C' ),
																new SQLField( 'anbieter', '%'.$ip_to_search.'%', 'C' ),
																new SQLField( 'kunde', '%'.$ip_to_search.'%', 'C' )
																);
	$lcWhere = $loFields->getSQLWhere( ' OR ' );
	$lcSQL = "SELECT count(*) FROM ipadressen WHERE $lcWhere";
	$loQuery = new SQLQuery( $lcSQL );
	$loQuery->doQuery();
	list($total_number) = $loQuery->fetchArray( 'N' );

	$lcSQL = "SELECT ip,anbieter,kunde FROM ipadressen WHERE $lcWhere".$lcOrder;
	$loQuery->Query( $lcSQL );

} else {
	$lcSQL = "SELECT ip,anbieter,kunde FROM ipadressen".$lcOrder;
	$loQuery = new SQLQuery( $lcSQL );
}

$loDS = new DataRowsDBValue( $loQuery, $page_size, $start_index - 1 );


$loCheck = new CheckDataField( '', 'ip' );
$loCheck->ParentAttribute( 'align', 'center' );

$loDS->Template( new TextDataField( '', 'ip', FALSE ),
								 new TextDataField( '', 'anbieter', FALSE ),
								 new TextDataField( '', 'kunde', FALSE ),
								 $loCheck 
								 );

$loDS->doQuery();


$loPTV = new PagedTableView( $loDS, $total_number );

$loCheckBox = new CheckDataField( 1, 'selectAll' );
$loCheckBox->Attribute('onclick', "javascript:checkedAll('ip', this.checked)");
$loSelValue = new DataValue( 'selectAll', 1, $loCheckBox );
$loSelValue->setTypeOfPresentation( 'Input' );

$laContent =array();

if( $order == 'reseller' ) {
	$laContent['reseller'] = new CompoundDataField( new HTMLDataField( ltext( 'eiip_cell_reseller' )),
																									new IconDataField( $lcDirIcon ));
	$laContent['reseller']->SetSeparator('');
 } else {
	$laContent['reseller'] = new HTMlDataField( ltext( 'eiip_cell_reseller' ) );
 }

if( $order == 'user' ) {
	$laContent['user'] = new CompoundDataField( new HTMLDataField( ltext( 'eiip_cell_user' )),
																							new IconDataField( $lcDirIcon ));
	$laContent['user']->SetSeparator('');
 } else {
	$laContent['user'] = new HTMlDataField( ltext( 'eiip_cell_user' ) );
 }

if( $order == 'ip' ) {
	$laContent['ip'] = new CompoundDataField( new HTMLDataField( ltext( 'eiip_cell_ip' )),
																						new IconDataField( $lcDirIcon ));
	$laContent['ip']->SetSeparator('');
 } else {
	$laContent['ip'] = new HTMlDataField( ltext( 'eiip_cell_ip' ) );
 }
 
 
$loPTV->Title(  new DataValue( 'ip', 
																						 NULL, 
																						 new LinkDataField( "javascript:setValue('order','ip',$listFormIndex);".
																																"setValue('start_index',1,$listFormIndex);".
																																"submitForm('direction','$lcNewDir',$listFormIndex)",
																																'',
																																array(),
																																$laContent['ip']
																																)
																						 ),
							  new DataValue( 'reseller', 
																						 NULL, 
																						 new LinkDataField( "javascript:setValue('order','reseller',$listFormIndex);".
																																"setValue('start_index',1,$listFormIndex);".
																																"submitForm('direction','$lcNewDir',$listFormIndex)",
																																'',
																																array(),
																																$laContent['reseller']
																																)
																						 ),
							  new DataValue( 'user', 
																						 NULL, 
																						 new LinkDataField( "javascript:setValue('order','user',$listFormIndex);".
																																"setValue('start_index',1,$listFormIndex);".
																																"submitForm('direction','$lcNewDir',$listFormIndex)",
																																'',
																																array(),
																																$laContent['user']
																																)
																						 ),
							 $loSelValue 
							 );

$laWidths = array( '20%', '40%', '37%', '3%' );
$loPTV->Widths( $laWidths );
$loPTV->Parameter( 'menu_node_id', $menu_node_id );
$loPTV->Parameter( 'cur_page', $cur_code );
$loPTV->Parameter( 'head_text', $head_text );
$loPTV->setParameter( 'order', $order );
$loPTV->setParameter( 'direction', $direction );

if (isset($ip_to_search)&&strlen($ip_to_search)) {
	$loPTV->NoItemsMessage(ltext('ll_empty_search'));
}	else {
	$loPTV->NoItemsMessage(ltext('ll_empty_list'));
}
	


$ptrnConfirm = ltext('eiip_confirm_delete');
$msgNothing = ltext('eiip_nothing_to_do');

$loTable = $loPTV->GetInputPresentation( array( 'action' => 'einstellungen_ip.php',
																								'method' => 'post',
																								'name' => 'list_ips'
																								),
																				 ltext("me_ip") );

$dsSearch = new CompoundValue( new ValueFromArray( 'ip_to_serach', $ip_to_search ),
															 new ValueLocale( 'll_search' ),
															 new ValueLocale( 'll_show_all' )
															 );
$loSearch = new SimpleSearchElement( array(), 
																		 new InputTextElement( array( 'name' => 'ip_to_search', 
																																	'size' => '16',
																																	'value' => $ip_to_search,
																																	'MAXLENGTH'=> '16' )
																														 )
																		 );
$loGroup = new DivElement(array('class'=>'buttons'));

if( $confixx_interface_version == 'powp' ) {
		$loSearch->appendElement( new PPButtonElement( '', 
																									 "javascript:submitForm('start_index',1)", 
																									 'bid-search' 
																									 )
															);
		$loSearch->appendElement( new PPButtonElement( '', 
																									 "javascript:setValue('ip_to_search','');submitForm('start_index',1)", 
																									 'bid-show-all'
																									 ) 
															);

		$loGroup->AppendToContent( new PPButtonElement( ltext('ll_delete'),
																										"javascript:deleteSelected( 'ip','$ptrnConfirm', 0, '$msgNothing' )",
																										'bid-delete' 
																										)
															 );		
} else {
	$loSearch->appendElement( new ButtonURLElement( '', "javascript:submitForm('start_index')" ) );
	$loSearch->appendElement(	new ButtonURLElement( '', "javascript:setValue('ip_to_search','');submitForm('start_index')" ) );

	$loGroup->AppendToContent( new ButtonURLElement( ltext('ll_delete'), "javascript:deleteSelected( 'ip','$ptrnConfirm', 0, '$msgNothing' )" ) );
}
																		 
$loSearch->setDataSource( $dsSearch, array( 'name' => $name ) );
if ((isset($ip_to_search)&&!strlen($ip_to_search))||$total_number>0) {
	$loTable->setSearchElement( $loSearch );
}
if ($total_number>0) {
	$loTable->setGroupActionElement( $loGroup );
}

$loTable->updateBodyContent();

//$loTable->AppendHelp( ltext('eiip_descr2') );


$loToolsData = new ToolsButtons( new ToolsButtonData( 'menu_head_ip_append', ltext('eiip_cell_title1'),'einstellungen_ip_auto.php'),
																 new ToolsButtonData( 'menu_head_ip_update', ltext('eiipau_button2'),'einstellungen_ip_autoupd.php',
																											array( 'cur_page' => 'einstellungen_ip.php',
																														 'head_text' => ltext( 'me_ip' ) ) )
																 );

	
$loTools = $loToolsData->GetInputPresentation();


$page = new MainPageElement( $loTools, $loTable );
$page->OutputHTML( array('../js/paged_form.js'), js_f_call_help('eiip_title1', 'eiip_descr1') );

db_close();
?>
