<?
include_once("auth.php");

include_once( "../include/elements/data/class.SetOfRowsData.php" );
include_once( "../include/elements/data/class.LongTextDataField.php" );
include_once( "../include/elements/data/class.HTMLDataField.php" );
include_once( "../include/elements/data/class.TextDataField.php" );
include_once( "../include/elements/data/class.CheckDataField.php" );
include_once( "../include/elements/html/class.MainPageElement.php" );

global $DEBUG;

if($DEBUG){
	echo "settings_ssl2<br>\n";
 }

db_connect();

if( $type ){

	if($type == 2 ){
		$id = safe_query2( "SELECT privatekey, crt FROM cssl WHERE kunde = 'admin'");
		list( $privatekey, $crt) = db_fetch_array($id, 'N');

	}else{
		$privatekey = '';
		$crt = '';
	}

	$data = new SetOfRowsData();
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_privatekey") ), 
										 new LongTextDataField( $privatekey, "privatekey" ) 
										 );
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_crt") ), 
										 new LongTextDataField( $crt, "crt" ) 
										 );

	$data->AppendButton( ltext("stssl_btn_save"), 
											 "javascript:doChange()", 
											 cc_IDOk  );

	$data->AppendHidden( new TextDataField( $type, "type" ) );
	$lcHelp = ltext('stssl_help_crt');

 }else{
	$id = safe_query2( "SELECT * FROM cssl WHERE kunde = 'admin'");
	
	if( db_num_rows( $id ) ){
		$row = db_fetch_array( $id );
		$firm = $row['firm'];
		$unit = $row['unit'];
		$city = $row['city'];
		$state = $row['state'];
		$countrycode = $row['countrycode'];
		$email = $row['email'];
		$common = $row['common'];
		$domain = $row['domain'];
	}

	$data = new SetOfRowsData();
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_firm") ), 
										new TextDataField( $firm, "firm" ) );
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_unit") ), 
										new TextDataField( $unit, "unit" ) );
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_city") ), 
										new TextDataField( $city, "city" ) );
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_state") ), 
										new TextDataField( $state, "state" ) );
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_countrycode") ), 
										new TextDataField( $countrycode,"countrycode" ) );
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_email") ), 
										new TextDataField( $email, "email" ) );
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_common") ), 
										new TextDataField( $common, "common" ) );

	$loSelfSigned = new CheckDataField( 1, "selfsigned" );
	$loSelfSigned->isChecked(1);
	$data->AppendRow( new HTMLDataField( ltext("stssl_cell_selfsigned") ), 
										$loSelfSigned );

	$data->AppendButton( ltext("stssl_btn_next"), 
											 "javascript:doChange()", 
											 cc_IDNext 
											 );

	$data->AppendHidden( new TextDataField( $type, "type" ) );

	$lcHelp = ltext('stssl_help_crs');

 }

$loForm = $data->GetInputPresentation( array( "action" => "settings_ssl_make.php",
																							"method" => "post" ), 
																			 $lcHelp );

$page = new MainPageElement( $loForm );

$page->OutputHTML();
?>