<?

include_once("auth.php");

include_once( "../include/class.SQLFieldSet.php" );

include_once( "../include/elements/data/class.SetOfRowsData.php" );
include_once( "../include/elements/data/class.HTMLDataField.php" );

include_once( "../include/elements/html/class.MainPageElement.php" );

global $DEBUG;
//$DEBUG=1; 

if($DEBUG){
	echo "settings_ssl_make: type: $type,  _POST<br><pre>\n";
	print_r($_POST);
	echo "</pre><hr>\n";
 }

db_connect();

if( $type ) { ## there are private key & certifucate

	if($privatekey && $crt){
		$id = safe_query2( "SELECT COUNT(*) FROM cssl WHERE kunde='admin'");
		list($count) = db_fetch_array($id);

		if( $count == 1 ){
			safe_query2( "UPDATE cssl SET privatekey=?, crt=? WHERE kunde='admin'",
									 new SQLString( $privatekey), new SQLString($crt));

		}else{
			if($count > 1){
				safe_query2( "DELETE FROM cssl WHERE kunde='admin'" );
				safe_query2( "INSERT INTO cssl (privatekey,crt,kunde,domain) ".
										 " VALUES (?,?,'admin','shared')",
										 new SQLString( $privatekey), new SQLString($crt)
										);

			}
		}

		
		$cmd = $bindir."/sslgen.pl admin match";
		if($DEBUG){
			echo "exec: $cmd<br>\n";
		}
		exec( $cmd, $devnull, $status);
		
		if ( $status == 0 ) {
			db_query( "UPDATE cssl SET aendern = 1 WHERE kunde = 'admin'"); 
			db_query( "UPDATE kunden SET httpd=1 WHERE cssl=1" );
			db_query( "UPDATE allgemein SET httpd=1, cssl=1" );

			$fehlertext = ltext("stssl_key_crt_ok");
			db_close();
			include("settings_ssl.php");
			exit;

		} else {
			$fehlertext = ltext("stssl_key_crt_no_valid");
		}

	}else{
		$fehlertext = ltext('stssl_help_crt');
	}

 }else{ ## make CRS or CRT

	$domain = 'shared';

	$loFields = new SQLFieldSet( array( 'loeschen' => 0, 
																			'aendern' => 1,
																			'neu' => 1,
																			'countrycode' => array($countrycode,'C'),
																			'state' => array( $state ,'C'), 
																			'city' => array( $city, 'C'), 
																			'firm' => array( $firm, 'C'), 
																			'unit' => array( $unit, 'C'), 
																			'email' => array( $email, 'C'), 
																			'common' => array( $common, 'C'),
																			'domain' => array( $domain, 'C' )
																		)
														 );

	$id = safe_query2( "SELECT COUNT(*) FROM cssl WHERE kunde='admin'");
	list($count) = db_fetch_array($id);
	
	if( $count == 1 ){
		$lcSQL = "UPDATE cssl SET ".$loFields->getSQLUpdate()." WHERE kunde='admin'";

	}else{
		if($count > 1){
			db_query( "DELETE FROM cssl WHERE kunde='admin'" );
		}
		list($lcFields,$lcValues) = $loFields->getSQLInsert();
		$lcSQL = "INSERT INTO cssl ( $lcFields, kunde )".
			" VALUES ( $lcValues, 'admin' )";
	}
	safe_query2( $lcSQL );

	$cmd = $bindir."/sslgen.pl admin $selfsigned";

	if($DEBUG){
		echo "exec: $cmd<br>\n";
	}

	exec($cmd, $crs, $status);

	if( $status == 0 ) {
		if ( $selfsigned ) {
			$type = 2;

		}else{ ## the certificate request is genereated

			$id = safe_query2("SELECT privatekey,csr FROM cssl WHERE kunde='admin'");
			list($privatekey,$csr) = db_fetch_array( $id, 'N');

			$data = new SetOfRowsData();
			$data->AppendRow( new HTMLDataField( ltext("stssl_cell_privatekey") ),
												new HTMLDataField( nl2br($privatekey) ) );
			$data->AppendRow( new HTMLDataField( ltext("stssl_cell_crs") ),
												new HTMLDataField( nl2br($csr) ) );
			$page = new MainPageElement( $data->GetOutputPresentation( "" ) );
			$page->AppendToHelp( array( '', 'stssl_crs_is_down' ) );
			$page->OutputHTML();

			exit;
		}

	}else{
		if( $crs[0] ){
			$fehlertext = mlf_text($crs[0]);
		}else{
			$fehlertext = "Error execute '$cmd': return code: $status";
		}
	}
 }

db_close();

include("settings_ssl2.php");

?>