<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

include_once("auth.php");
include_once( "../include/class.SQLString.php" );
include_once( "../include/elements/data/class.SetOfRowsData.php" );
include_once( "../include/elements/data/class.HTMLDataField.php" );
include_once( "../include/elements/data/class.TextDataField.php" );
include_once( "../include/elements/data/class.ReadOnlyDataField.php" );
include_once( "../include/elements/data/class.CompoundDataField.php" );
include_once( "../include/elements/data/class.YesNoDataField.php" );

include_once( "../include/elements/html/class.MainPageElement.php" );

global $DEBUG;
//$DEBUG=1;
/*
if($DEBUG){
	echo "kunde_aendern_loeschen.php<br>\n";
}
*/

## mysql verbindung aufbauen
db_connect($db_host, $db_user, $db_pass);
## /mysql verbindung aufbauen

$laToDelete = array();

if ( $PHP_AUTH_USER == 'res0' && $kunde == $user_prefix.'0'){
	$forbidden=1;
}else{
## domains ins array

	$loRes = new SQLString( $PHP_AUTH_USER );
	if( is_array( $users ) && count($users)) {
		$loFields = new SQLFieldSet();
		foreach( $users as $lcUser ){
			$loFields->addField('kunde',$lcUser,'C');
		}
		$lcWhere = $loFields->getSQLValues();
		$id = safe_query2( "SELECT k.kunde, d.domain FROM kunden k ".
											 " LEFT JOIN domains d ON k.kunde = d.kunde AND d.richtigedomain NOT IN (2,3)".
											 " WHERE k.kunde IN ($lcWhere) AND k.anbieter=? ORDER BY k.kunde,d.domain", $loRes );
		while( $row = db_fetch_array( $id ) ) {
			$kunde = $row['kunde'];
			if( $kunde == $user_prefix.'0'){ // can't delete web0
				$forbidden = 1;
			} else {
				if(!array_key_exists( $kunde, $laToDelete )){
					$laToDelete[$kunde] = array();
				}
				array_push( $laToDelete[$kunde],  $row["domain"] );
			}
		}

	} elseif($kunde) {
		$id = safe_query2( "SELECT domain FROM domains WHERE richtigedomain NOT IN (2,3) ".
											 " AND kunde = ?  AND anbieter = ? ", 
											 new SQLString( $kunde ), $loRes );
		$laToDelete[$kunde] = array();
		while ($werte = db_fetch_array($id)){
			array_push( $laToDelete[$kunde],  $werte["domain"] );
		}
	} else {
		$fehlertext = ltext('kuaelo_nothing');
		popPathBar( TRUE );
		include('kunden_start.php');
		exit;
	}
## /domains ins array
}
/*
echo "<br><pre>\n";
print_r($laToDelete);
echo "</pre><hr>\n";
*/

/* -------------------- HTML -------------------- */
$data = new SetOfRowsData();
if( $forbidden ) {
	$loMsg = new HTMLDataField( ltext( "kuaelo_forbidden", $kunde, $PHP_AUTH_USER ) );
	$loMsg->SetColSpan(2);
	$data->AppendRow( $loMsg );
	$data->AppendHidden( new TextDataField( "nein", "loeschen" ) );
}

foreach( $laToDelete as $kunde => $domains ){
	
	$loConfirm = new HTMLDataField( ltext( "kuaelo_descr1", $kunde ) );
	$loDomains = new CompoundDataField();
	foreach( $domains as $domain ){
		$loDomain = new ReadOnlyDataField( $domain );
		$loDomain->AddParentTag( 'strong' );
		$loDomains->AppendToContent( $loDomain );
	}
	$loDomains->SetSeparator( "<br>" );

	$loYesNo = new YesNoDataField( array( 'ja' => ltext( "kuaelo_text1", $kunde ) ), 
																 array( 'nein' => ltext( "kuaelo_text2", $kunde ) ), 
																 'ja', 
																 'loeschen['.$kunde.']', 
																 cc_RadioGroupPresentation 
																 );
	$loYesNo->AppendParentAttributes(array('rowspan'=>2));

	$data->AppendRow( $loConfirm, $loYesNo );
	$data->AppendRow( $loDomains );

	$data->AppendHidden( new TextDataField( $kunde, 'kunde[]' ) );

}
$data->AppendButton( ltext("kuaelo_button1") ,"javascript: doChange()", cc_IDOk);


$loForm = $data->GetInputPresentation( array( 'method'=>'post',
																							'action'=>'kunden_aendern_loeschen2.php' ), 
																			 ltext( 'kuae_cell_delete') 
																			 );
$loForm->SetWidths( '50%', '50%' );
$page = new MainPageElement( $loForm );
$page->AppendToHelp( array( "", "kuaelo_title1" ) );
$page->OutputHTML();
/* -------------------- end HTML -------------------- */
?>
