<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

include_once("auth.php");
include_once( "../include/class.SQLInteger.php" );
include_once( "../include/class.SQLFieldSet.php" );

global $DEBUG;
//$DEBUG=1;

if($DEBUG){
	echo "tools_domains_loeschen2.php: _POST<br><pre>\n";
	print_r($_POST);
	echo "</pre><hr>\n";
}
db_connect();

$goUser = new SQLString( $PHP_AUTH_USER );

$domain_ids = array();
if(is_array($loeschen)) {
	$fehlertext = '';
	foreach( $loeschen as $id => $lcYN ) {
		if ( $lcYN != 'ja') 
			break;
		else 	
			$domain_ids [] = $id;
	}
	$update_db = TRUE;

	// Loop by domains
	foreach( $domain_ids as $id) { 
		$loDomainID = new SQLInteger( $id );
		$res = safe_query2( "SELECT domain FROM domains WHERE id=? AND richtigedomain != 1 AND kunde=? ", $loDomainID, $goUser );
		list($lcDomain) = db_fetch_array( $res );
		if ($DEBUG) {
			echo 'tools_domains_loeschen2.php: lcDomain<br><pre>';
			var_dump($lcDomain);
			echo '</pre>';
		}

		// Get list of emails
		$laEmails = array();
		$res = safe_query2( "SELECT ident, prefix, domain FROM email WHERE domain = ? AND kunde = ?",$lcDomain, $goUser );
		while( list( $ident,$prefix,$edomain ) = db_fetch_array( $res, 'N' ) ) {
			$laEmails[$prefix.'@'.$edomain] = $ident;
		}

		if ($DEBUG) {
			echo 'tools_domains_loeschen2.php: laEmails<br><pre>';
			var_dump($laEmails);
			echo '</pre>';
		}
		if( $update_db && count( $laEmails ) ) {
			$loFields = new SQLFieldSet( array( 'account' => array( '','C'),
																					'type' => array( 'alias','C'),
																					'kunde' => array( $goUser, 'C'),
																					'pfad' => array( '', 'C' )
																					)
																	);
			$lcFlds = $loFields->getSQLNames();
			foreach( $laEmails as $email => $ident ) {
				list( $prefix, $edomain ) = split( '@', $email, 2 );
				$loFields->updateField( 0, $prefix );
				$loFields->updateField( 3, $edomain );
				$lcVals = $loFields->getSQLValues();
				safe_query2( "INSERT INTO delaccs( $lcFlds ) VALUES ( $lcVals )" );
			}							 
			$lcIDs = join(',',array_values($laEmails));
			safe_query2( "DELETE FROM autoresponder WHERE kunde=? AND ident IN ($lcIDs)", $goUser );					 
			safe_query2( "DELETE FROM email WHERE kunde=?  AND ident IN ($lcIDs)",  $goUser );					 
			safe_query2( "DELETE FROM email_forward WHERE kunde=? AND email_ident IN ($lcIDs)", $goUser );					 
		}

		//
		// get list of at-domains
		//
		$laAtDomains = array();
		$res = safe_query2( "SELECT a.id, a.name, d.domain FROM atdomains a, domains d ".
												" WHERE d.kunde =? ".
												" AND a.id_from=d.id AND d.id =? ", $goUser, $loDomainID );
		while( list( $atid,$name,$atdomain ) = db_fetch_array( $res, 'N' ) ){
			$laAtDomains[$name.'@'.$atdomain] = $atid;
		}

		if ($DEBUG) {
			echo 'tools_domains_loeschen2.php: laAtDomains<br><pre>';
			var_dump($laAtDomains);
			echo '</pre>';
		}
		if( $update_db && count( $laAtDomains ) ) {
			$lcIDs = join(',',array_values($laAtDomains));
			safe_query2( "DELETE FROM atdomains WHERE id IN ($lcIDs)" );
		}

		//delete maillists
		safe_query2( "UPDATE maillist SET neu=3 WHERE domain_id = ?", $loDomainID );
		domain_aendern($lcDomain, "loeschen", $PHP_AUTH_USER);
		fpalias_aendern($lcDomain, "loeschen", $PHP_AUTH_USER);
		safe_query2( "DELETE FROM idn_aliases WHERE domain_id =? ",$loDomainID);		
		safe_query2( "DELETE FROM domains WHERE id =? AND kunde=? ", $loDomainID, $goUser );
		$fehlertext .= ltext("todolo_error4",array($lcDomain)).'<br>';
	}
	if( $update_db ) {
		db_query("UPDATE kunden SET httpd=1 WHERE kunde=?", $goUser);
		set_countdomains($goUser);
		safe_query2( "UPDATE kunden SET changedomains = 1 WHERE kunde = ?", $goUser);
	}

}

db_close();

popPathBar( TRUE );
include("tools_domains.php");

?>