<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####


class Traffic {
  var $dateBegin;
  var $dateEnd;
  var $user;
  var $reseller;
  var $sql;
  var $log;
  var $traffic;
  var $month;
  var $year;
  var $interval;
  var $fields;
  var $allFields;
  var $group;
  var $groups;
  var $blocked;
  var $maOrder;

  function Traffic (){
    $this->dateEnd = getdate();
    $this->dateBegin = $this->dateEnd;
    $this->dateBegin["mday"]=1;
    $this->month=$this->dateEnd["mon"];
    $this->year=$this->dateEnd["year"];
    $this->interval=false;
    $this->fields=array('web','ftp','email'); ### ,'pop','other');
		$this->allFields=array('web','ftp','email'); ###,'pop','other');
    $this->log=1;
    $this->maOrder = array();
  }
	
  function setGroup ($newValue){
    if(is_string($newValue) || is_bool($newValue) ){
      $this->group=$newValue;
    }elseif(is_array($newValue)){
      $this->group=array();
      foreach ($newValue as $field){
	if(is_string($field)){
	  $this->group[]=$field;
	}
      }
      if(!count($this->group)){
	$this->group=false;
      }	
    }
    return $this->group;
  }
	
  function getGroup (){
    return $this->group;
  }
	
  function setBegin ($newValue,$month=false,$mday=false){
    if (is_array($newValue)){
      $this->dateBegin=$newValue;
      return $this->dateBegin;
    }elseif(is_string($newValue)){
      list($year,$month,$mday)=split('[-/.]',$newValue);
    }elseif( is_int($newValue)){
      $year=$newValue;
    }
    if( is_int($year) && is_int($month) && is_int($mday) ){
      $this->dateBegin["year"]=$year;
      $this->dateBegin["mon"]=$month;
      $this->dateBegin["mday"]=$mday;
    }
    return $this->dateBegin;
  }
  
  function getBegin (){
    return $this->dateBegin;
  }
	
  function setEnd ($newValue,$month=false,$mday=false){
    if (is_array($newValue)){
      $this->dateEnd=$newValue;
      return $this->dateEnd;
    }elseif(is_string($newValue)){
      list($year,$month,$mday)=split('[-/.]',$newValue);
    }elseif( is_int($newValue)){
      $year=$newValue;
    }
    if( is_int($year) && is_int($month) && is_int($mday)){
      $this->dateEnd["year"]=$year;
      $this->dateEnd["mon"]=$month;
      $this->dateEnd["mday"]=$mday;
    }
    return $this->dateEnd;
  }

  function getEnd (){
    return $this->dateEnd;
  }

  function setMonth ($newValue, $year=''){
    if(is_bool($newValue) || is_int($newValue)){
      $this->month=$newValue;
    }
    if(is_bool($year) || is_int($year)){
      $this->year=$year;
    }
    return $this->month;
  }

  function getMonth (){
    return $this->month;
  }

  function Order( $paOrder = NULL ) {
		if( is_array( $paOrder ) ) {
				$this->maOrder = $paOrder;
		}
		return $this->maOrder;
	}
	
  function setYear ($newValue){
    if(is_bool($newValue) || is_int($newValue)){
      $this->year=$newValue;
    }
    return $this->year;
  }

  function getYear (){
    return $this->year;
  }

  
  function setUser ($newValue, $blocked=0){
    if(is_bool($newValue) || is_string($newValue)){
      $this->user=$newValue;
    }
    if(is_bool($blocked) || is_int($blocked)){
      $this->blocked=$blocked;
    }
    return $this->user;
  }

  function getUser (){
    return $this->user;
  }

  function setBlocked ($newValue){
    if(is_bool($newValue) || is_int($newValue)){
      $this->blocked=$newValue;
    }
    return $this->blocked;
  }

  function getBlocked(){
    return $this->blocked;
  }

  function setReseller ($newValue){
    if(is_bool($newValue) || is_string($newValue)){
      $this->reseller=$newValue;
    }	
    return $this->reseller;
  }

  function getReseller (){
    return $this->reseller;
  }
	
  function setLog ($newValue){
    if(is_int($newValue) || is_bool($newValue)){
      $this->log=$newValue;
    }
    return $this->log;
  }
  function getLog (){
    return $this->log;
  }

  function setFields($newValue){
    if(is_array($newValue)){
      $this->fields=array();
      foreach($newValue as $key){
	if (in_array($key,$this->allFields)){
	  $this->fields[]=$key;
	}
      }	
    }
    return $this->fields;
  }		
	
  function getFields(){
    return $this->fields;
  }
  
  function getSql (){
    return $this->sql;
  }

  function makeSql(){
		
    if (!count($this->fields)){
      $this->fields=array($this->allFields);
    }
    foreach ( $this->fields as $field){
      if (in_array($field,$this->allFields)){
	if ($fields){
	  $fields.=",";
	}
	$fields.="sum($field) as $field";
      }
    }
    if(!$fields){
      return false;
    }
    if($this->group){
      if(is_array($this->group)){
	foreach($this->group as $field){
	  $fields.=",$field";
	}
      }else{
	$fields.=','.$this->group;
      }	
    }
    
    $sql="select $fields from transfer";
    $where='';
    if($this->interval){
      $begin=$this->dateBegin["year"]*10000+$this->dateBegin["mon"]*100+$this->dateBegin["mday"];
      $end=$this->dateEnd["year"]*10000+$this->dateEnd["mon"]*100+$this->dateEnd["mday"];
      $where.=($where?"and":"")."((jahr*10000+monat*100+tag) between $begin and $and)";
    }else{
      if(is_int($this->year)){
	$where.=($where?"and":"")."(jahr=".$this->year.")";
      }
      if(is_int($this->month)){
	$where.=($where?"and":"")."(monat=".$this->month.")";
      }
    }
    if (is_int($this->log)){
      $where.=($where?"and":"")."(log=".$this->log.")";
    }
    if (is_string($this->reseller)){
      $where.=($where?"and":"")."(anbieter='".$this->reseller."')";
    }
    if (is_string($this->user)){
      $where.=($where?"and":"")."(kunde='".$this->user."')";
    }
    if (is_int($this->blocked)){
      $where.=($where?"and":"")."(geloescht=".$this->blocked.")";
    }
    
    if ($where){
      $sql.=" where $where";
    }
    if($this->group){
      if(is_array($this->group)){
	$group='';
	foreach($this->group as $field){
	  $group.=($group?",":"")."$field";
	}
      }else{
	$group=$this->group;
      }
      if($group){
	$sql.=" group by $group";
      }
    }
    
	if (count($this->maOrder)) {
   	$lcOrderBy = " ORDER BY ";
   	foreach ($this->maOrder as $key => $value) {
  		$lcOrderBy .= $key." ".$value.", ";
   	}
   	$lcOrderBy = substr($lcOrderBy, 0 , -2);
   	$sql .= $lcOrderBy;
  }
		    
    $this->sql=$sql;
    global $DEBUG;
    if($DEBUG){
      echo "sql: $sql<br>\n";
    }
    return $this->sql;
  }

  function Query(){

    global $DEBUG;

    if($this->makeSql()){
      $id=db_query($this->sql);
      if($id){
	$this->traffic=array();
	$this->groups=array();
	if ($this->group){
	  if(is_array($this->group)){
	    while($row=db_fetch_array($id)){
	      $node=&$this->traffic;
	      $groupValue=array();
	      foreach($this->group as $field){
						$key=$row[$field];
						if(! is_array($node[$key])){
						  $node[$key]=array();
						}
				
				#		if($DEBUG){
				#		  echo "field: $field, key: $key<br>\n";
				#		  print_r($node);
				#		  echo "<br>\n";
				#		}
				
						$node=&$node[$key];
						$groupValue[]=$key;
	      }
	      $node=$row;
	      $this->groups[]=$groupValue;

#	      if($DEBUG){
#		echo "key: $key<br>\n";
#		print_r($node);
#		echo "<br>\n";
#	      }

	    }	
	    if($DEBUG){
	      echo "groups:<br>\n";
	      print_r($this->groups);
	      echo "<br>\n";
	    }

	  }else{
	    while($row=db_fetch_array($id)){
	      $key=$row[$this->group];
	      $this->traffic[$key]=$row;
	    }	
	  }	
	}else{
	  while($row=db_fetch_array($id)){
	    $this->traffic[]=$row;
	  }
	}
      }	

      if($DEBUG){
	echo "traffic:<br>\n";
	print_r($this->traffic);
	echo "<br>\n";
      }

      $ret=$this->traffic;
    }else{
      $ret=false;
    }
    return $ret;
  }

  function monthlyQuery($month = false, $year = false){
  global $DEBUG;
    if($DEBUG){
      echo "month: $month, year: $year<br>\n";
    }
    if(is_bool($month)){
      $this->month=$month;
    }else{
      $month=0+$month;
      if($month){
	$this->month=$month;
      }
    }
    if(is_bool($year)){
      $this->year=$year;
    }else{
      $year=0+$year;
      if(0+$year){
	$this->year=$year;
      }
    }
    $this->interval=false;
    if($DEBUG){
      echo "month: $this->month, year: $this->year<br>\n";
    }
    return $this->Query();
  }
	
  function getTraffic($key = false, $group=false){

    global $DEBUG;
#    if($DEBUG){
#      echo "getTraffic: key: $key, group: $group<br>\n";
#    }


    if (is_string($key)){
      $ret = 0;
      if(in_array($key,$this->fields)){
	if ($group){
	  if(is_array($group)){
	    $node = &$this->traffic;
	    foreach($group as $field){
	      $node = &$node[$field];
	    }
	    $ret += $node[$key];
	  }else{
	    $ret += $this->traffic[$group][$key];
	  }
	}else{
	  foreach($this->traffic as $row){	
	    $ret += $row[$key];
	  }
	}
      }elseif($key == 'all' || $key == 'sum'){
	if ($group){
	  if(is_array($group)){
	    $node = &$this->traffic;
	    foreach($group as $field){
	      $node = &$node[$field];
	    }
	    foreach($this->fields as $field){
	      $ret += $node[$field];
	    }
	  }else{
	    foreach($this->fields as $field){
	      $ret += $this->traffic[$group][$field];
	    }
	  }
	}else{
	  foreach($this->traffic as $row){	
	    foreach($this->fields as $field){
	      $ret += $row[$field];
	    }
	  }	
	}
      }else{
	$ret=false;
      }
    }else{
      if($group){
	if(is_array($group)){
#	  if($DEBUG){
#	    echo "group:<br>\n";
#	    print_r($group);
#	    echo "<br>\n";
#	  }
	  $node = &$this->traffic;
	  foreach($group as $field){
#	    if($DEBUG){
#	      echo "field: $field<br>\n";
#	      print_r($node);
#	      echo "<br>\n";
#	    }
	    $node = &$node[$field];
	  }
#	  if($DEBUG){
#	    echo "node: <br>\n";
#	    print_r($node);
#	    echo "<br>\n";
#	  }

	  $ret = $node;	
	}else{
	  $ret = $this->traffic[$group];
	}
      }else{
	$ret = $this->traffic;
      }
    }
    if($DEBUG){
      echo "getTraffic: return<br>\n";
      print_r($ret);
      echo "<br>\n";
    }
    return $ret;
  }
	
  function getGroupTraffic($key = false){
    $ret=array();
    if (is_string($key)){
      if(in_array($key,$this->fields)){
	if($this->group){	
	  if(is_array($this->group)){
	    copyArray($ret,$this->traffic,count($this->group),$key);
	  }else{
	    foreach($this->traffic as $row){
	      $gkey=$row[$this->group];
	      $ret[$gkey] = $row[$key];
	    }
	  }	
	}else{
	  foreach($this->traffic as $row){
	    $ret[]=$row[$key];
	  }	
	}		
      }elseif($key == 'all' || $key == 'sum'){
	if($this->group){	
	  if(is_array($this->group)){
	    copyArray($ret,$this->traffic,count($this->group),$this->fields);
	  }else{
	    foreach($this->traffic as $row){	
	      $gret=0;
	      foreach($this->fields as $field){
		$gret+=$row[$field];
	      }	
	      $gkey=$row[$this->group];
	      $ret[$gkey] = $gret;
	    }	
	  }	
	}else{
	  foreach($this->traffic as $row){	
	    $gret=0;
	    foreach($this->fields as $field){
	      $gret+=$row[$field];
	    }	
	    $ret[]=$gret;
	  }
	}
      }else{
	$ret=false;
      }
    }else{
      $ret=$this->traffic;
    }
    return $ret;
  }
	
  function getGroups(){
    global $DEBUG;
    if(is_array($this->group)){
      $ret=$this->groups;
    }else{
      $ret = array_keys($this->traffic);
    }	
    if($DEBUG){
      echo "getGroups:<br>\n";
      print_r($ret);
      echo "<br>\n";
    }
    return $ret;
  }
}



	
#
# end of class definition
#

#
# recurent copy multi-dimensional array
#

function copyArray(&$dst,&$src,$level,&$keyField){
  if ($level){
    while (list($key,$val) = each($src)){
      $dst[$key]=array();
      copyArray($dst[$key],$val,$level-1,$key);
    }
  }else{
    if($key){
      if(is_array($keyField)){
	$sum=0;
	foreach($keyField as $field){
	  $sum+=$src[$field];
	}
	$dst[$field]=$sum;
      }else{
	$dst[$keyField]=$src[$keyField];
      }	
    }	
  }	
}


?>
