<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction

  Constant names:

  cc_DescriptionOfConstant

  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/

include_once ("auth.php");
include_once ("defines.php");
include_once ( "../include/class.User.php" );
include_once ( "../include/class.Reseller.php" );
include_once ( "../include/module.Database.php" );
include_once( "../include/elements/data/class.LikePagedRowsData.php" );
include_once ( "../include/limits/class.AllLimits.php" );
include_once( "../include/elements/data/class.SetOfRowsData.php" );
include_once( "../include/elements/data/class.HTMLDataField.php" );
include_once( "../include/elements/data/class.TextDataField.php" );
include_once( "../include/elements/data/class.CompoundDataField.php" );
include_once( "../include/elements/data/class.CheckDataField.php" );
include_once( "../include/elements/data/class.ButtonData.php" );
include_once( "../include/elements/data/class.OptionsDataField.php" );
include_once( "../include/data_source/class.CompoundValue.php" );
include_once( "../include/data_source/class.KeyValue.php" );
include_once( "../include/elements/html/class.MainPageElement.php" );
include_once( "../include/elements/html/class.PPButtonElement.php" );
include_once( '../include/class.PathBar.php' );

global $DEBUG;
//$DEBUG=1;

if($DEBUG){
	
	echo "kunden_neu4: POST:<br><pre>\n";
	print_r($_POST);
	echo "</pre><hr>\n";
	
	/*
	echo "GET:<br><pre>\n";
	print_r($_GET);
	echo "</pre><hr>\n";
	 echo "kunden_neu4.php: _SESSION<br><pre>\n";
        print_r( $_SESSION );
        echo "</pre><hr>\n";
	*/
}
db_connect();


$loPathBar = new PathBar();
$loPathBar->cloneTop( array( 'cur_page' => 'kunden_neu4.php',
														 'path_text'=>ltext('kune4_cell_domains')
														 ) 
											);

$loRes = new Reseller();
$ga_Reseller = $loRes->GetFields();


$go_User = new User();
$loUser = new SQLString( $PHP_AUTH_USER );
$laSet = $loPathBar->getSettings( 'kunden_neu4.php' );
if( is_array( $laSet ) ) {
	$laData = array_merge( $laSet, $_POST );
 } else {
	$laData =& $_POST;
 }

$go_User->InitializeServices ( $ga_Reseller );
$go_User->SetServicesData ( $laData );

$go_User->InitializePersonal ();
$go_User->SetPersonalData ( $laData );



if( $action ) {

	$loPathBar->removeSettings( 'kunden_neu4.php', 'dns', 'dnr', 'action');
	$loPathBar->saveRequest( 'kunden_neu4.php', 'safe' );
	$loPathBar->restoreRequest( 'kunden_neu4.php', 'safe' );	
			
	if( !is_array( $domain ) ) {
		$domain = array();
		$domdnr = array();
		$domdns = array();
	}

	switch($action){

	case 'ok':
		include('kunden_neu5.php');
		exit;
		break;

	case 'new':
		$lcDomain = $loRes->validateDomain( $new_domain, $domain );
		if( $lcDomain ) {
			$ind = count($domain)+1;
			$domain[$ind] = $lcDomain;
			$domdns[$ind] = $dns; 
			$domdnr[$ind] = $dnr;

			$loPathBar->appendSetting( 'kunden_neu4.php', 'domain' );
			$loPathBar->appendSetting( 'kunden_neu4.php', 'domdns' );
			$loPathBar->appendSetting( 'kunden_neu4.php', 'domdnr' );

			if (strtolower(trim($new_domain)) != $lcDomain) {
				$natdomain[$ind] = strtolower(trim($new_domain));
				$loPathBar->appendSetting( 'kunden_neu4.php', 'natdomain' );
			}
			
		}else{
			$llKeepNew = 1;
		}
		break;

	case 'delete':
		if( is_array( $domain_ids ) ) {
			foreach($domain_ids as $ind){
				unset( $domain[$ind]);
				unset( $domdns[$ind]);
				unset( $natdomain[$ind]);
				unset( $domdnr[$ind]);
 			}
 			
 			$t_domain = array();
 			$t_domdns = array();
 			$t_domdnr = array();
 			$t_natdomain = array();
			$i=1;
			foreach ($domain as $key => $value) {
				$t_domain[$i] = $value;
				if (isset($domdns[$key])&&!empty( $domdns[$key])) $t_domdns[$i] = $domdns[$key];
				if (isset($domdnr[$key])&&!empty( $domdnr[$key])) $t_domdnr[$i] = $domdnr[$key];
				if (isset($natdomain[$key])&&!empty( $natdomain[$key])) $t_natdomain[$i] = $natdomain[$key];
				$i++;
			}
 			$domain = $t_domain;
 			$domdns = $t_domdns;
 			$domdnr = $t_domdnr;
 			$natdomain = $t_natdomain;
 			
			$loPathBar->appendSetting( 'kunden_neu4.php', 'domain' );
			$loPathBar->appendSetting( 'kunden_neu4.php', 'domdns' );
			$loPathBar->appendSetting( 'kunden_neu4.php', 'domdnr' );
			$loPathBar->appendSetting( 'kunden_neu4.php', 'natdomain' );

		}
		break;
		case 'refresh':
			$loPathBar->appendSetting( 'kunden_neu4.php', 'domain' );
			$loPathBar->appendSetting( 'kunden_neu4.php', 'domdns' );
			$loPathBar->appendSetting( 'kunden_neu4.php', 'domdnr' );
			$loPathBar->appendSetting( 'kunden_neu4.php', 'natdomain' );
		break;
	}
	if( ! $llKeepNew ) {
		$new_domain = '';
	}

 }else{

	if( $target == 'next' ){
		$loPathBar->saveRequest( 'kunden_neu3.php' );
	}
	$loPathBar->saveRequest( 'kunden_neu4.php' ); 

	if( $neupw1 ){
		if( $neupw1 != $neupw2 ){
			$fehlertext = ltext( 'kuaepw2_error2' );
			$target = 'back';
			include("kunden_neu3.php");
			exit();
		}
		if (!valid_pw( $neupw1 ) ) {
			$fehlertext = ltext( 'kuaepw2_error3' );
			$target = 'back';
			include("kunden_neu3.php");
			exit();
		}
	}

/* -------------------- verify personal information & services/limits -------------------- */


	if ( ! $go_User->ValidateServices() ) {
		$datenausdbholen = "nein";
		$target = 'back';
		include ( "kunden_neu2.php" );
		exit;
	}

	if ( ! $go_User->ValidatePersonal() )	{
		$datenausdbholen = "nein";
		$target = 'back';
		include ( "kunden_neu3.php" );
		exit;
	}
/* -------------------- end verify personal information & services/limits -------------------- */

 }



$skdns = $ga_Reseller['dns'];
$skdnr = $ga_Reseller['dnr'];
$standardIP = $ga_Reseller['standardip'];
if( ! $standardIP ) {
	$id = safe_query2( "SELECT standardip FROM admin" );
	list($standardIP) = db_fetch_array( $id );
}

if( $loRes->CanAddDomains( count( $domain ) ) ){

	$loRD = new SetOfRowsData();
	
	$loRow =& $loRD->AppendRow( new HTMLDataField(ltext('ed_domain')),
															new TextDataField( $new_domain, 'new_domain' )
															);
	if( $skdns ){
		$loRow->AppendFields( new CheckDataField( 1, 'dns' ),
													new HTMlDataField( ltext( 'kune4_cell_dns1' ) )
													);
		if( $skdnr){
			$loRow->AppendFields( new CheckDataField( 1, 'dnr' ),
														new HTMlDataField( 'DNR' )
													);
		}
	}

	$loRow->AppendFields( new ButtonData(ltext( 'll_add' ),'javascript:doChange()', cc_IDAdd ) );

	$loRD->AppendHidden( new TextDataField( 'new', 'action' ) );

	$loAppendForm = $loRD->GetInputPresentation( array( 'action' => 'kunden_neu4.php',
																											'method' => 'post',
																											'name' => 'append_new' ),
																							 ltext( 'll_add' )
																							 );
	$liFormIndex = 1;
} else {
	$loAppendForm = NULL;
	$liFormIndex = 0;
}

// end add form
//
//==========================================================
//
// list of domains

$total_number = count($domain);
if ($total_number) {
	$tmp_domain = array();
	foreach ($domain as $key=>$value) {
		if (isset($natdomain[$key])&&!empty($natdomain[$key])) 
			$tmp_domain[$key] = $natdomain[$key];
		else 
			$tmp_domain[$key] = $domain[$key];
	}
}
$loRows = new LikePagedRowsData();
$liColspan = 2;
$loRows->appendHidden( new TextDataField( 'next', 'target' ) );

$loRows->AppendButton(ltext("kune1_back"), 
											"javascript:setValue('target','back',$liFormIndex);".
											"goPrevPage('kunden_neu3.php',$liFormIndex)",
											cc_IDBack,
	array('type' => 'reset',
		'tabindex' => 1) 
	);

if( !$total_number ){
	$loRows->AppendRow( new HTMLDataField( ltext("kune5_error16") ) );

 } else {
	$loDS = new CompoundValue();
	$i=0;
	foreach( $tmp_domain as $ind => $lcDomain){
		$i++;
		$loDS->addValue( new CompoundValue( new KeyValue( "domain", $lcDomain ),
																				new KeyValue( "dns", $domdns[$ind]?1:0 ),
																				new KeyValue( "dnr", $domdnr[$ind]?1:0 )
																				)
										 );
	}
	
	$loRow =& $loRows->AppendHeaderRow( new HTMLDataField( ltext('ed_domain'),false,array(),array('width' => '95%')));

	if( $skdns ) {
		$loRow->AppendFields( new HTMLDataField( 'DNS' ) );
		$liColspan = 3;

		if( $skdnr){
			$loRow->AppendFields( new HTMLDataField( 'DNR' ) );
			$liColspan = 4;
		}
	}

	$loCheckBox = new CheckDataField( 1, 'selectAll' );
	$loCheckBox->Attribute('onclick', "javascript:checkedAll('domain_ids', this.checked, $liFormIndex)");
	$loCheckBox->SetParentAttributes(array('align'=>'center'));

	$loRow->AppendFields( $loCheckBox );


	$loIter =& $loDS->getFirstIterator();

	$laOn = array('checked'=>NULL);
	$laOff = array();

	$i=0;
	while( $loItem =& $loIter->getNext()){

		$i++;

		$loDomain =& $loItem->Value(0);
		$loRows->AppendRow();
		$lcDomain = $loDomain->Value();
		$loRows->AppendFields( new HtmlDataField( $lcDomain ) );
//		$loRows->AppendHidden( new TextDataField( $lcDomain, "domain[$i]" ) );
		$loRows->AppendHidden( new TextDataField( $domain[$i], "domain[$i]" ) );
		$loRows->AppendHidden( new TextDataField( $natdomain[$i], "natdomain[$i]" ) );
//		$loRows->AppendHidden( new HtmlDataField( $domidn, "domidn[$i]" ) );
		if( $skdns ){
			$loVal = $loItem->Value(1);

			$loRows->AppendFields( new CheckDataField( 1, 
																								 "domdns[$i]", 
																								 ($loVal->Value()? $laOn: $laOff),
																								 array( 'align' => 'center' )
																								 ) 
														 );
			if( $skdnr ){
				$loVal = $loItem->Value(2);
				$loRows->AppendFields( new CheckDataField( 1, 
																									 "domdnr[$i]", 
																									 ($loVal->Value()? $laOn: $laOff),
																									 array( 'align' => 'center' )
																									 )
															 );
			}
		}
		$loRows->AppendFields( new CheckDataField( $i, 
																							 "domain_ids[]",
																							 $laOff,
																							 array( 'align' => 'center' )
																							 )
													 );

	}

	$loRows->AppendHeaderRow( new HTMlDataField(ltext( 'kune4_title3' ),array(),array( 'colspan'=> $liColspan )));
	$loExclusive = new CheckDataField( 1, 'exclusiv', ($exclusiv?$laOn:$laOff));

	$laOptions = array();
	$laOptions['standard'] = ltext('kune4_cell_select_stdip');

	$id = safe_query2( "SELECT ip FROM ipadressen WHERE anbieter=? AND  kunde='' AND ip != ? ORDER BY ip", 
										 $loUser, new SQLString($standardIP));
	while(list($ip) = db_fetch_array( $id ) ){
		$laOptions[$ip] = $ip;
	}

	$loIPRow = new CompoundDataField( new OptionsDataField( $laOptions, $ip, 'ip'),
																	$loExclusive,
																	new HTMlDataField( ltext('kune4_cell_text3'))
																	);
	$loIPRow->SetSeparator(' ');
	$loIPRow->ParentAttribute( 'colspan', $liColspan );

	$loRows->AppendRow();

	$loRows->AppendFields( $loIPRow	);

	$loRows->AppendButton( ltext('ll_apply'),
												 "javascript:setValue('action','refresh',$liFormIndex);doChange($liFormIndex)",
												 cc_IDOk,
		array('type'=>'submit',
			'tabindex'=>'1') 
		);
	$loRows->AppendButton( ltext('ll_next_2'),
												 "javascript:doChange($liFormIndex)",
												 cc_IDNext,
		array('type'=>'submit',
			'tabindex'=>'0') 
		);

	$loRows->appendHidden( new TextDataField( 'ok', 'action' ) );


#
# pass user's settings
#

	$loRows->appendHidden( new TextDataField( $neupw1, 'neupw1' ) );

	for ( $go_User->FirstService(); $go_Column =& $go_User->NextService(); ){
		$loRows->AppendHidden ( new TextDataField( $go_Column->GetValue(), 
																							 $go_Column->GetName() 
																							 ) 
														);
	}
	$loRows->AppendHidden( new TextDataField( $kbtyp, 'kbtype' ) );
	$loRows->AppendHidden( new TextDataField( $ident, 'ident' ) );
	$loRows->AppendHidden( new TextDataField( 'nein', 'datenausdbholen' ) );


	for ( $go_User->FirstPersonal(); $go_Column =& $go_User->NextPersonal(); ){
		$loRows->AppendHidden ( new TextDataField( $go_Column->GetValue(), 
																							 $go_Column->GetName() 
																							 ) 
														);
	}

 }


$loForm = $loRows->GetInputPresentation( array( 'method' => 'post',
																								'action' => 'kunden_neu4.php'
																								),
																				 ltext( 'kuae_cell_domain' )
																				 );
if ($total_number) {
	$loGroup = new DivElement(array('class'=>'buttons'));
	$head_text = ltext( 'll_delete' );
	$lcConfirm = ltext( 'll_confirm_delete' );
	$lcNothing = ltext( 'll_nothing' );
	$loGroup->AppendToContent( new PPButtonElement( $head_text,
																									"javascript:setValue('action','delete',$liFormIndex);".
																									"deleteSelected('domain_ids','$lcConfirm',$liFormIndex,'$lcNothing')",
																									'bid-delete'
																									)
														 );

	$loForm->setGroupActionElement( $loGroup );
}
$loPage = new MainPageElement( $loAppendForm, $loForm );

$loPage->OutputHTML( array( "../../js/common.js",
														'../../js/paged_form.js'
														) 
										 );
?>
