<?include_once( "../include/class.SQLString.php" );?><?
####### Confixx(R) 2.0 Professional
### Copyright Yippi-Yeah! E-Business GmbH 2001-2003
####### http://www.confixx.de - info@yippi-yeah.com
include_once("auth.php");
include("../languages/".$shortlang."/scripts.inc.php");

include_once( "class.SQLFieldSet.php" );
include_once( "../include/elements/data/class.SetOfRowsData.php" );
include_once( "../include/elements/data/class.HTMLDataField.php" );
include_once( "../include/elements/data/class.ButtonURLData.php" );

include_once( "../include/elements/html/class.MainPageElement.php" );

global $DEBUG;
//$DEBUG=1;

if($DEBUG){
	echo "kunden_ssl_erstellen3.php : _POST<br><pre>\n";
	print_r($_POST);
	echo "</pre><hr>\n";
 }


## mysql verbindung aufbauen
db_connect($db_host, $db_user, $db_pass);
## /mysql verbindung aufbauen

$loUser = new SQLString( $PHP_AUTH_USER );

$id = safe_query2( "SELECT cssl FROM anbieter WHERE anbieter = ? ", $loUser );
$werte = db_fetch_array($id);
$skssl = $werte["cssl"];

if ($skssl < 1)	{
	$fehlertext = ltext("kusser_error1");
	db_close();
	popPathBar();
	include("kunden_start.php");
	exit();
}

$loKunde = new SQLString($kunde);
## prfen, ob kunde eigene ip adresse hat
$id = safe_query2( "SELECT COUNT(*) FROM ipadressen WHERE kunde = ?  AND anbieter = ? ",
									 $loKunde, $loUser );
list($count) = db_fetch_array($id);
if ( $count < 1)	{
	$fehlertext = ltext("kusser_error2", array($kunde));
	db_close();
	include("kunden_ssl.php");
	exit();
}
## //

## daten in Datenbank schreiben

$loFields = new SQLFieldSet( array( 'aendern' => 1,
																		'loeschen' => 0,
																		'neu' => 1,
																		'countrycode' => array($countrycode,'C'),
																		'state' => array( $state ,'C'), 
																		'city' => array( $city, 'C'), 
																		'firm' => array( $firm, 'C'), 
																		'unit' => array( $unit, 'C'), 
																		'email' => array( $email, 'C'), 
																		'common' => array( $common, 'C')
																		)
														 );

$id = safe_query2( "SELECT COUNT(*) FROM cssl WHERE kunde = ? ", $loKunde );
list($count) = db_fetch_array($id);

if ( $count < 1)	{
	list ($lcFields,$lcValues) = $loFields->getSQLInsert();
	$lcSQL = "INSERT INTO cssl ( kunde, anbieter, $lcFields ) VALUES ( ?, ?, $lcValues )";
	safe_query2( $lcSQL, $loKunde, $loUser );

} else	{
	$lcSQL = "UPDATE cssl SET ".$loFields->getSQLUpdate()." WHERE kunde=? AND anbieter=?";
	safe_query2( $lcSQL, $loKunde, $loUser );
}


$cmd = $bindir."/sslgen.pl $kunde $selfsigned";

//echo "cmd: $cmd<br>\n";

exec($cmd, $crs, $status);

if ($status != 0)	{
	db_close();
	$fehlertext = mlf_text($crs[0]);
	include("kunden_ssl_erstellen2.php");
	exit();
}

if ( $selfsigned ) {

	db_close();
	include( "kunden_ssl_erstellen.php" );
	exit();
}


$id = safe_query2( "SELECT privatekey, csr FROM cssl WHERE kunde = ?  AND anbieter = ? ", 
									 $loKunde, $loUser );
$werte = db_fetch_array($id);
$privatekey = $werte["privatekey"];
$csr = $werte["csr"];
safe_query2( "UPDATE cssl SET neu=1,aendern=0,loeschen=1 WHERE kunde = ? AND anbieter = ? ", 
						 $loKunde, $loUser );


/* -------------------- HTML -------------------- */
$data = new SetOfRowsData();
$data->AppendRow( new HTMLDataField( ltext("kusser3_cell_privatekey") ), new HTMLDataField( nl2br($privatekey) ) );
$data->AppendRow( new HTMLDataField( ltext("kusser3_cell_crs") ), new HTMLDataField( nl2br($csr) ) );


$data->AppendRow( new ButtonURLData( ltext('ll_back'), 'kunden_ssl.php'));



$page = new MainPageElement( $data->GetOutputPresentation( "" ) );
$page->AppendToHelp( array( '', 'kusser3_title1' ) );
$page->OutputHTML();
/* -------------------- end HTML -------------------- */
?>
