<?include_once( "../include/class.SQLInteger.php" );include_once( "../include/class.SQLString.php" );?><?
####### Confixx(R) 2.0 Professional
### Copyright Yippi-Yeah! E-Business GmbH 2001-2003
####### http://www.confixx.de - info@yippi-yeah.com
include_once("auth.php");

#global $DEBUG;
#$DEBUG=1;

include_once("../events.inc.php");
include_once("../include/event_functions.php");

$time = time();
db_connect($db_host, $db_user, $db_pass);

$id = safe_query( "select standardip from admin", TRUE );
$werte = db_fetch_array($id);
$oldstandardip = $werte["standardip"];
$standardip = trim($standardip);
$usestd = $usestd? 0: 1;

## domain checken
if ((!ereg("\.", $standarddomain)) || (ereg("[^a-z0-9.-]", $standarddomain)) || (ereg("^-", $standarddomain)))
	{
	 $fehlertext = ltext("eisd2_error1");
	 db_close();
	 include("einstellungen_stddomain.php");
	 exit();
	}

## ip checken
if (!ereg("([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})", $standardip))
	{
	 $fehlertext = ltext("eisd2_error3");
	 db_close();
	 include("einstellungen_stddomain.php");
	 exit();
	}

$loIP = new SQLString( $standardip );
$id = safe_query2( "select * from ipadressen where ip = ? ", $loIP );
if (db_num_rows($id) != 0){
	 $fehlertext = ltext("eisd2_error4");
	 db_close();
	 include("einstellungen_stddomain.php");
	 exit();
	}	 


safe_query2( "update admin set standarddomain = ? , standardip = ? , stddomain = ? ", 
						 new SQLString( $standarddomain ), $loIP, new SQLInteger( $usestd ) );

eventAdd($OBJECT_IP,$EVENT_CHANGE);

if ($all == 1){
	$id = safe_query2( "select * from domains where richtigedomain = 3" );
	 while ($werte = db_fetch_array($id)){
		 $kunde = $werte["kunde"];
		 $anbieter = $werte["anbieter"];
		 $olddomain = $werte["domain"];
		 $newdomain = $kunde.".".$standarddomain;

	 	 domain_aendern($olddomain, "loeschen", $kunde);
		 fpalias_aendern($olddomain, "loeschen", $kunde);

		 $loKunde = new SQLString( $kunde );

		 safe_query2( "update domains set domain = ? , lastchange = ?  where domain = ?  and richtigedomain = 3 and kunde = ? ", 
									new SQLString( $newdomain ), new SQLInteger( $time ), new SQLString( $olddomain ), $loKunde );

		 safe_query2( "UPDATE kunden SET httpd=1 WHERE kunde=?",$loKunde);

	 	 domain_aendern($newdomain, "anlegen", $kunde);
		 fpalias_aendern($newdomain, "anlegen", $kunde);
		}
	}
safe_query2( "update anbieter set standardip = ?  where standardip = ? ", 
						 $loIP, new SQLString( $oldstandardip ) );	 
safe_query2( "update kunden set ip = ?, httpd=1  where ip = ? ", 
						 $loIP, new SQLString( $oldstandardip ) );	 
safe_query2( "update allgemein set httpd = 1");

$fehlertitel = ltext("eisd2_errortitle");
$fehlertext = ltext("eisd2_error2");
db_close();
include("einstellungen_stddomain.php");
exit();

?>
