<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/





include_once ( dirname(__FILE__) . "/module.Database.php" );
include_once ( dirname(__FILE__) . "/class.MenuItems.php" );





class MenuBlocks
{
    /* -------------------- Members -------------------- */
    var $mo_Query; // query object
    var $ms_ID; // id of block
    var $ms_Text; // text of block
    var $ms_UserType;
    /* -------------------- end Members -------------------- */





    /* -------------------- Constructor -------------------- */
    function MenuBlocks ( $ps_UserType )
    {
			$this->ms_UserType = $ps_UserType;
    }
    /* -------------------- end Constructor -------------------- */





    /* -------------------- iteration -------------------- */
    function Start()
    {
			$lo_DB =& get_db_connection();
			$this->mo_Query =& $lo_DB->Select ( "SELECT * FROM menublock WHERE usertype=" . db_full_quote($this->ms_UserType) .
																					" ORDER BY id" );
			if( ! $this->mo_Query->getNumRows() ){
				$this->mo_Query = NULL;
			}
    }

    function NextElement()
    {
			if( ! is_object( $this->mo_Query ) ){
				return NULL;
			}
			$la_Row = $this->mo_Query->nextrow();
			if ( ! $la_Row ){
				return NULL;
			}
			$this->ms_ID = $la_Row["id"];
			$this->ms_Text = htmlspecialchars($la_Row["label"],ENT_QUOTES);
			return new MenuItems ( $la_Row["id"] );
    }
    /* -------------------- end iteration -------------------- */





    /* -------------------- access to one element -------------------- */
    function GetLabel()
    {
			return $this->ms_Text;
    }

    function GetID()
    {
			return $this->ms_ID;
    }
    /* -------------------- end access to one element -------------------- */

}
?>
