<?
include_once("auth.php");

include_once( 'class.EmailHeaderSet.php' );

include_once( "../include/elements/data/class.SetOfRowsData.php" );
include_once( "../include/elements/data/class.HTMLDataField.php" );
include_once( "../include/elements/data/class.ReadOnlyDataField.php" );
include_once( "../include/elements/data/class.CompoundDataField.php" );
include_once( "../include/elements/data/class.LinkDataField.php" );
include_once( "../include/elements/data/class.OptionsDataField.php" );
include_once( "../include/elements/data/class.YesNoDataField.php" );

include_once( "../include/elements/html/class.MainPageElement.php" );

global $DEBUG;
//$DEBUG=1;

if(array_key_exists('mailnum', $_GET))
{
	setcookie('mailnum', $_GET['mailnum'] * 1, time() + (3600 * 24 * 365));
	$_COOKIE['mailnum'] = $_GET['mailnum'] * 1;
}


include("email_functions.php");
include("email_config.php");
include("email_header.php");

$id = db_query ( "SELECT 1 FROM pop3 WHERE account='$cnf_user' AND neu=1" );
if ( db_fetch_array($id) ){
    echo ( ltext("wmail_notcreated") );
    exit();
}

/* POP3-Connect: */
if (!e_connect()) { 
echo ltext("wmail_pop3");
exit();
}

$numMessages = imap_num_msg($mbox);
$numkey = 0;
if($numMessages == 0){
	echo $lang_text["wbm_msglist_nomails"];
}else{
	$id = safe_query2( "SELECT admin.spamfilter AS adm_spam, ".
										 "kunden.spamfilter AS user_spam, kunden.list_size AS list_size".
										 " FROM admin, kunden WHERE kunde=?",
										 new SQLString( $kunde ) );

	$res = db_fetch_array($id);
	//$pagesize = $res['list_size'];
	$adm_spam = $res['adm_spam'];
	$user_spam = $res['user_spam'];
	

//	loadHeaders($order,$show,$start_index,$page_size);
	

	if(array_key_exists('mailnum', $_COOKIE))	{
		$pagesize = $_COOKIE['mailnum'] * 1;
	}
	
	if(!$pagesize)	{
		$pagesize = 20;	
	}
	
	if(!$page){
		$page = 0;	
	}
	
	$page_start = $page * $pagesize;
	$page_end = ($page + 1) * $pagesize - 1;
	for($i = $numMessages; $i >= 1; $i--)
	{
		$showit = true;
		//$ht = imap_fetchheader($mbox, $i, FT_PREFETCHTEXT);
		if($adm_spam && $user_spam && array_key_exists('show', $_GET))
		{
			//$re = '/^X-Spam-Flag\: YES$/';
			//echo $re;
			//$showit = preg_match('/X-Spam-Flag\: YES/', imap_fetchheader($mbox, $i, FT_PREFETCHTEXT));

			if($show == 'spam')	{
				$showit = preg_match('/X-Spam-Flag\: YES/', imap_fetchheader($mbox, $i, FT_PREFETCHTEXT));	
			}
			
			if($show == 'nospam'){
				$showit = !preg_match('/X-Spam-Flag\: YES/', imap_fetchheader($mbox, $i, FT_PREFETCHTEXT));	
			}
		}
		
		
		if ( $showit )	{
			$header = imap_headerinfo($mbox, $i);

			if($DEBUG){
				echo "$i:<br><pre>\n";
				print_r( $header );
				echo "</pre><hr>\n";
			}

			$subject = $header->subject;
			$date = dateFormat(strtotime($header->date),"datetime");
			$bodystruct = imap_fetchstructure($mbox, $i);
			$size = $bodystruct->bytes;			
			$sortdate = dateFormat(strtotime($header->date),"sortdate");
			
			//$struct_header = headerArray($bodystruct);
			//if($struct_header["parameters"]["charset"])
			//{
			$subject = decode_subject($subject);
			//}
			
			//print_r($struct_header);
			
			$fromname = $header->from[0]->personal;
			$host = $header->from[0]->host;
			$mailbox = $header->from[0]->mailbox;
			if ($host == ".MISSING-HOST-NAME.")
			{
				$host="localhost";
			}
			$fromaddress = "<".$mailbox . "@" . $host.">";
			
			$sender = (isset($fromaddress)) ? $fromname." ".$fromaddress : $fromname;
			$sender = htmlspecialchars(mimeHeaderDecode($sender));
			
			/* Generate Messagelist ($msglist): */
			$msglist["msgid"][$numkey] = $i;
			$msglist["subject"][$numkey] = htmlentities(strtolower($subject));
			$msglist["subject_output"][$numkey] = $subject;
			if($msglist["subject_output"][$numkey] == "")
			{
				$msglist["subject_output"][$numkey] = "[".$lang_text["wbm_nosubject"]."]";
			}
			$msglist["sender"][$numkey] = htmlentities(strtolower($sender));
			$msglist["sender_output"][$numkey]  = $sender;
			$msglist["date"][$numkey] = $sortdate;
			$msglist["date_output"][$numkey] = $date;
			$msglist["size"][$numkey] = $size;
			$msglist["size_output"][$numkey] = sizeFormat($size);
			$msglist["status1"][$numkey] = $status1;
			$msglist["status2"][$numkey] = $status2;
			$numkey++;
		}
	}
	
	$numMessages = $numkey;
	
	if($page_end > $numMessages)
	{
		$page_end = $numMessages - 1;
	}
	$pages = ceil($numMessages / $pagesize); 
	
	//echo "-- $numkey -- $numMessages --";
	
	/* Sort generated Messaglist */
	$id = db_query("SELECT sortfield, sortorder FROM pop3 WHERE kunde='" . $kunde . "'" . " AND account='".$PHP_AUTH_USER."'");
	$sortinfo = db_fetch_array($id);
	$sortfield = $sortinfo['sortfield'];
	$sortorder = $sortinfo['sortorder'];
	
	if (!$orderby) {
		if ($sortfield) $orderby = $sortfield;
		if ($sortorder) $sort = $sortorder;
		$update_sortinfo = 0;
	}
	else $update_sortinfo = 1;
	
	if($orderby == "subject" || $orderby == "sender" || $orderby == "date" || $orderby == "size")
	{
		if($sort == "desc")
		{
			// DESC
			$sort = "desc";
			array_multisort($msglist["$orderby"], SORT_REGULAR, SORT_DESC, $msglist["msgid"], $msglist["subject"], $msglist["subject_output"], $msglist["sender"], $msglist["sender_output"], $msglist["date"], $msglist["date_output"], $msglist["size"], $msglist["size_output"]);
			$sortlink["$orderby"] = "email_postfach.php?orderby=$orderby" . (array_key_exists('show', $_GET)?"&show=$show":'');
		}
		else
		{
			// ASC
			$sort = "asc";
			array_multisort($msglist["$orderby"], SORT_REGULAR, SORT_ASC, $msglist["msgid"], $msglist["subject"], $msglist["subject_output"], $msglist["sender"], $msglist["sender_output"], $msglist["date"], $msglist["date_output"], $msglist["size"], $msglist["size_output"]);
			$sortlink["$orderby"] = "email_postfach.php?orderby=$orderby&sort=desc" . (array_key_exists('show', $_GET)?"&show=$show":'');
		}
		
		if ($update_sortinfo) $id = db_query("UPDATE pop3 SET sortfield='".$orderby."', sortorder='".$sort."' WHERE kunde='" . $kunde . "'" . " AND account='".$PHP_AUTH_USER."'");
	}
	
	/* -------------------------- HTML ------------------------- */
	$JSscriptPart = '';
	$JSscriptInclude = array();
	$JSscriptInclude[] = "email_webmail.js";
	
	$JSscriptPart .= "function messagesSelected(){\n".
					"    var i;\n".
					"    if ( document.del_form.ids.length ) {\n".
					"        for ( i=0; i < document.del_form.ids.length; i++ )\n".
					"            if ( document.del_form.ids[i].checked )\n".
					"            return true;\n".
					"    }\n".
					"    else return document.del_form.ids.checked;\n".
					"    return false;\n".
					"}\n\n";
	
	$JSscriptPart .= "function deleteMessages() {\n".
					"    if ( ! messagesSelected() ) {\n".
					"    ".js_alert(ltext("wbm_nomessages_selected")).";\n".
					"    return;\n".
					"    }\n".
					"    if ( ".js_confirm(ltext("wbm_confirm_delete")).")\n".
					"        document.del_form.submit();\n".
					"}\n\n";
	
	$JSscriptPart .= "function deleteOneMessage(ID) {\n".
					"    if ( ".js_confirm(ltext("wbm_confirm_delete_one")).")\n".
					"        location.href='email_delete.php?msgDelMail='+ID;\n".
					"}\n\n";
	
	$showmessages = new SetOfRowsData();
	
	if($adm_spam && $user_spam) {
		$mess_type = array(
			"all"=>ltext("wbm_show_all"),
			"spam"=>ltext("wbm_show_spam"),
			"nospam"=>ltext("wbm_show_nospam")
		);
		if ($show == 'all' || !$show) $sel_type = "all";
		elseif ($show == 'spam') $sel_type = "spam";
		elseif ($show == 'nospam') $sel_type = "nospam";
	}
	
	$mess_num = array(
		"20"=>ltext("wbm_show_page20"),
		"50"=>ltext("wbm_show_page50"),
		"100"=>ltext("wbm_show_page100"),
		"100000000"=>ltext("wbm_show_pageall")
	);
	if ($pagesize == 20 || !$pagesize) $sel_num = "20";
	elseif ($pagesize == 50) $sel_num = "50";
	elseif ($pagesize == 100) $sel_num = "100";
	elseif ($pagesize == 100000000) $sel_num = "100000000";

	if($adm_spam && $user_spam) $showmessages->AppendRow(new OptionsDataField($mess_type,$sel_type,"show"), new OptionsDataField($mess_num,$sel_num,"mailnum"),
														new ButtonData (ltext('wbm_show'), 'javascript:document.forms[\'sel_spam\'].submit()', cc_IDOk));
	else $showmessages->AppendRow( new OptionsDataField($mess_num,$sel_num,"mailnum"),
								new ButtonData (ltext('wbm_show'), 'javascript:document.forms[\'sel_spam\'].submit()', cc_IDOk));
	
	$listmessages = new SetOfRowsData();
	
	if ($numMessages > 0) {
	if($sortlink["subject"]) {
		$subj_link = $sortlink["subject"];
		$subj_field = $lang_text["wbm_subject"].'<img src="'.$strSkinName."/webmail_icons/".$sort.'.gif" border="0">';
	}
	else {
		$subj_link = "email_postfach.php?orderby=subject" . (array_key_exists('show', $_GET)?"&show=$show":'');
		$subj_field = $lang_text["wbm_subject"];
	}
	$subj_cell = new LinkDataField($subj_link,"",array(),$subj_field);

	if($sortlink["sender"]) {
		$from_link = $sortlink["sender"];
		$from_field = $lang_text["wbm_sender"].'<img src="'.$strSkinName."/webmail_icons/".$sort.'.gif" border="0">';
	}
	else {
		$from_link = "email_postfach.php?orderby=sender" . (array_key_exists('show', $_GET)?"&show=$show":'');
		$from_field = $lang_text["wbm_sender"];
	}
	$from_cell = new LinkDataField($from_link,"",array(),$from_field);

	if($sortlink["date"]) {
		$date_link = $sortlink["date"];
		$date_field = $lang_text["wbm_date"].'<img src="'.$strSkinName."/webmail_icons/".$sort.'.gif" border="0">';
	}
	else {
		$date_link = "email_postfach.php?orderby=date" . (array_key_exists('show', $_GET)?"&show=$show":'');
		$date_field = $lang_text["wbm_date"];
	}
	$date_cell = new LinkDataField($date_link,"",array(),$date_field);	

	if($sortlink["size"]) {
		$size_link = $sortlink["size"];
		$size_field = $lang_text["wbm_size"].'<img src="'.$strSkinName."/webmail_icons/".$sort.'.gif" border="0">';
	}
	else {
		$size_link = "email_postfach.php?orderby=size" . (array_key_exists('show', $_GET)?"&show=$show":'');
		$size_field = $lang_text["wbm_size"];
	}
	$size_cell = new LinkDataField($size_link,"",array(),$size_field);
	
	$listmessages->AppendHeaderRow( new HTMLDataField("&nbsp;"), $subj_cell, $from_cell, $date_cell, $size_cell );
	
	for($i = $page_start; $i <= $page_end; $i++) {
		$email_check = new YesNoDataField( array($msglist["msgid"][$i]=>""), array(), "", "ids[]" );
		$email_check->SetAttributes(array("id"=>"ids"));
		
		$email_subj = new LinkDataField("email_message.php","id=".$msglist["msgid"][$i],array(),
						$msglist["status1"][$i].$msglist["status"][$i].htmlspecialchars($msglist["subject_output"][$i]).$msglist["status2"][$i]);
		$email_from = new HTMLDataField( $msglist["status1"][$i].$msglist["sender_output"][$i].$msglist["status2"][$i] );
		$email_date = new HTMLDataField( $msglist["status1"][$i].$msglist["date_output"][$i].$msglist["status2"][$i] );
		$email_size = new HTMLDataField( $msglist["status1"][$i].$msglist["size_output"][$i].$msglist["status2"][$i] );
		
		$listmessages->AppendRow( $email_check, $email_subj, $email_from, $email_date, $email_size );
	}
	
	$activate_link = new LinkDataField("javascript:deActivateAll()","",array(),$lang_text["wbm_msglist_select"]);
	$activate_link->SetColSpan("2");
	
	$page_links = new CompoundDataField();
	$page_links->SetSeparator("");
	
	if($page > 0) {
		$prev_link_url = "email_postfach.php?page=".($page-1);
		if($orderby) $prev_link_url .= "&orderby=".$orderby;
		if($sort == 'desc') $prev_link_url .= "&sort=".$sort;
		if(array_key_exists('show', $_GET)) $prev_link_url .= "&show=".$show;
		$prev_link = new LinkDataField($prev_link_url, "", array(), ltext('g_prev'));
		$page_links->AppendToContent($prev_link);
	}
	
	for($j = 0; $j < $pages; $j++) {
		if($page != $j) {
			$page_link_url = "email_postfach.php?page=".$j;
			if($orderby) $page_link_url .= "&orderby=".$orderby;
			if($sort == 'desc') $page_link_url .= "&sort=".$sort;
			if(array_key_exists('show', $_GET)) $page_link_url .= "&show=".$show;
			$page_link = new LinkDataField($page_link_url, "", array(), "[".($j+1)."]");
			$page_links->AppendToContent($page_link);
		}
		else {
			$page_links->AppendToContent( new HTMLDataField("[".($j+1)."]") );
		}
	}

	if($page < ($pages - 1)) {
		$next_link_url = "email_postfach.php?page=".($page+1);
		if($orderby) $next_link_url .= "&orderby=".$orderby;
		if($sort == 'desc') $next_link_url .= "&sort=".$sort;
		if(array_key_exists('show', $_GET)) $next_link_url .= "&show=".$show;
		$next_link = new LinkDataField($next_link_url, "", array(), ltext('g_next'));
		$page_links->AppendToContent($next_link);
	}
	
	$listmessages->AppendRow( $activate_link, new HTMLDataField("&nbsp;"), new HTMLDataField("&nbsp;"), $page_links );
	$blank_field = new HTMLDataField( "&nbsp;" );
	$blank_field->SetColSpan("5");
	$listmessages->AppendRow( $blank_field );
	$note_field = new HTMLDataField( ltext("wbm_msglist_selected") );
	$note_field->SetColSpan("5");
	$listmessages->AppendRow( $note_field );
	
	$listmessages->AppendButton( ltext("wbm_delete"), "javascript:deleteMessages()", cc_IDOk );
	}
		
	$page = new MainPageElement( $showmessages->GetInputPresentation( array( "action"=>"email_postfach.php", "method"=>"get", "name"=>"sel_spam" ), ltext("m_postfach") ),
								 $listmessages->GetInputPresentation( array( "action"=>"email_delete.php", "method"=>"post", "name"=>"del_form" ), ltext('wbm_msglist_status', array(($page_end - $page_start + 1), $numMessages)) ) );
	$page->OutputHTML($JSscriptInclude, $JSscriptPart);	
	/* -------------------------- end HTML --------------------- */	
}

/* POP3-Disconnect: */
imap_close($mbox);
?>
