<?
####### Confixx(R) 2.0 Professional
### Copyright Yippi-Yeah! E-Business GmbH 2001-2003
####### http://www.confixx.de - info@yippi-yeah.com
include_once("auth.php");

include_once( "../include/elements/data/class.SetOfRowsData.php" );
include_once( "../include/elements/data/class.OptionsDataField.php" );
include_once( "../include/elements/data/class.LongTextDataField.php" );
include_once( "../include/elements/data/class.HTMLDataField.php" );
include_once( "../include/elements/data/class.TextDataField.php" );
include_once( "../include/elements/data/class.CheckDataField.php" );
include_once( "../include/elements/html/class.MainPageElement.php" );

global $DEBUG;
//$DEBUG=1;

if($DEBUG){
	echo "kunden_ssl_erstellen2.php : _POST<br><pre>\n";
	print_r($_POST);
	echo "</pre><hr>\n";
 }

## mysql verbindung aufbauen
db_connect($db_host, $db_user, $db_pass);
## /mysql verbindung aufbauen

$loUser = new SQLString($PHP_AUTH_USER);

$id = safe_query2( "SELECT cssl FROM anbieter WHERE anbieter=?", $loUser);
$werte = db_fetch_array($id);
$skssl = $werte["cssl"];

if ($skssl < 1)	{
	$fehlertext = ltext("kusser_error1");
	db_close();
	include("kunden_start.php");
	exit();
}

## pruefen, ob kunde eigene ip adresse hat
$loKunde  = new SQLString($kunde);
$id = safe_query2( "SELECT COUNT(*) FROM ipadressen WHERE kunde = ? AND anbieter = ?",
									 $loKunde, $loUser );
list($count) = db_fetch_array($id);
if ($count < 1)	{
	$fehlertext = ltext("kusser_error2", array($kunde));
	include("kunden_ssl.php");
	db_close();
	exit();
}
## //

if ($vorhanden == 1){
	$id = safe_query2( "SELECT privatekey, crt FROM cssl WHERE kunde = ? AND anbieter = ? AND loeschen = 0", $loKunde, $loUser);
	 $werte = db_fetch_array($id);
	 $privatekey = $werte["privatekey"];
	 $crt = $werte["crt"];
}





/* -------------------- HTML -------------------- */
if( $vorhanden == 0 ) {
	$id = safe_query2( "SELECT * FROM cssl WHERE kunde = ? AND anbieter=?", $loKunde, $loUser);
	if( db_num_rows( $id ) ){
		$row = db_fetch_array( $id );
		$firm = $row['firm'];
		$unit = $row['unit'];
		$city = $row['city'];
		$state = $row['state'];
		$countrycode = $row['countrycode'];
		$email = $row['email'];
		$common = $row['common'];
	}

	$data = new SetOfRowsData();
	$data->AppendRow( new HTMLDataField( ltext("kusser2_cell_firm") ), 
										new TextDataField( $firm, "firm" ) );
	$data->AppendRow( new HTMLDataField( ltext("kusser2_cell_unit") ), 
										new TextDataField( $unit, "unit" ) );
	$data->AppendRow( new HTMLDataField( ltext("kusser2_cell_city") ), 
										new TextDataField( $city, "city" ) );
	$data->AppendRow( new HTMLDataField( ltext("kusser2_cell_state") ), 
										new TextDataField( $state, "state" ) );
	$data->AppendRow( new HTMLDataField( ltext("kusser2_cell_countrycode") ), 
										new TextDataField( $countrycode,
				"countrycode" ) );
	$data->AppendRow( new HTMLDataField( ltext("kusser2_cell_email") ), 
										new TextDataField( $email, "email" ) );
	$data->AppendRow( new HTMLDataField( ltext("kusser2_cell_common") ), 
										new TextDataField( $common, "common" ) );
	$data->AppendRow( new HTMLDataField( ltext("kusser2_cell_selfsigned") ), 
										new CheckDataField( 1, "selfsigned" ) );

	$data->AppendHidden( new TextDataField( $kunde, "kunde" ), 
											 new TextDataField( $vorhanden, "vorhanden" ) );

	$data->AppendButton( ltext("kusser2_btn_next"), "javascript:doChange()",cc_IDNext );

	$loForm = $data->GetInputPresentation( array( "action"=>"kunden_ssl_erstellen3.php",
																								"method"=>"post" ), 
																				 ltext("mk_ssl") 
																				 );
	$page = new MainPageElement( $loForm );
	$page->OutputHTML();

}else {
	$adata = new SetOfRowsData();

	$adata->AppendRow( new HTMLDataField( ltext("kusser2_cell_privatekey") ), 
										 new LongTextDataField( $privatekey, "privatekey" ) 
										 );
	$adata->AppendRow( new HTMLDataField( ltext("kusser2_cell_crt") ), 
										 new LongTextDataField( $crt, "crt" ) );

	$adata->AppendHidden( new TextDataField( $kunde, "kunde" ) );

	$adata->AppendButton( ltext("kusser2_btn_save"), "javascript:doChange(0)",cc_IDOk );

	$adata->GetInputPresentation( array( "action" => "kunden_ssl_aktivieren.php", 
																			 "method" => "post" 
																			 ),
																ltext("kusser2_activate") 
																);

	$loForm = $adata->GetInputPresentation( array( "action"=>"kunden_ssl_aktivieren.php",
																								 "method"=>"post" ), 
																					ltext( "kusser2_activate" ) 
																					);
	$page = new MainPageElement( $loForm );
	$page->OutputHTML();
}
/* -------------------- end HTML -------------------- */
?>
