<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/

include_once ("auth.php");
include_once ("../include/class.User.php");
include_once ("../include/module.Database.php");
include_once ("../include/class.FormPage.php");
include_once ("../include/class.FormPageHeaderRow.php");
include_once ("../include/class.FormPageRow.php");
include_once ("../include/class.ButtonColumn.php");
include_once ("../include/class.InputHiddenColumn.php");
include_once ("../include/elements/data/class.TextLimit.php");
include_once ("../include/elements/data/class.TrafficLimit.php");
include_once ("../include/elements/data/class.KBLimit.php");
include_once ("../include/elements/html/class.MainPageElement.php");
include_once ("../include/elements/data/class.MultiSetData.php");

include_once( '../include/class.PathBar.php' );

global $DEBUG;
//$DEBUG=1;

if($DEBUG){
	echo "kunden_neu2.php: _POST<br><pre>\n";
	print_r( $_POST );
	echo "</pre><hr>\n";
 }


$loPathBar = new PathBar();
$loPathBar->cloneTop( array( 'cur_page' => 'kunden_neu2.php',
														 'path_text'=>ltext('kune2_cell_feature')
														 ) 
											);
if( $target == 'next' ){
	$loPathBar->saveRequest( 'kunden_neu1.php' );
 }


/* -------------------- initialize form -------------------- */
$go_DB =& get_db_connection();
$go_Query =& $go_DB->Select ( "SELECT * FROM anbieter WHERE anbieter = " . db_full_quote($PHP_AUTH_USER) );
$ga_Reseller =& $go_Query->nextrow();

$go_User = new User();
$go_User->InitializeServices ( $ga_Reseller );

$gs_NewUser = istleer($kunde);
$laSet = $loPathBar->getSettings( 'kunden_neu2.php' );

if( $datenausdbholen == "nein" || 
		( is_array($laSet) && array_key_exists('maxkb',$laSet) ) 
		){
	
	if( is_array( $laSet ) ) {
		$laData = array_merge($laSet, $_POST);
	} else {
		$laData =& $_POST;
	}
	
	$go_User->SetServicesData ( $laData );
	
 }elseif( is_numeric($ident) ) {
	 $go_User->SetServicesFromSQL ( "SELECT * FROM angebote WHERE ident =  $ident".
																	" AND anbieter = " .
																	db_full_quote($PHP_AUTH_USER) );
 }elseif( !$gs_NewUser ){
 	 $go_Query =& $go_DB->Select ( "SELECT * FROM kunden WHERE kunde = ".db_full_quote($kunde) );
	 $go_User->SetServicesFromArray ( $go_Query->nextrow());
 }

// maps from old classes to include/elements/*
$go_Limits = new SetOfRowsData();
for ( $go_User->FirstService(); $go_Column =& $go_User->NextService() &&
		( strtolower(get_class($go_Column)) == "limitcolumn" || is_subclass_of( $go_Column, "limitcolumn" ) ); ) {
	switch ( strtolower(get_class($go_Column)) ) {
		case "resellerstoragecolumn":
			switch ( $kbtyp ) {
				case "MB":
					$gs_Value = $go_Column->GetValue()*1024;
					break;
				case "GB":
					$gs_Value = $go_Column->GetValue()*1024*1024;
					break;
				default:
					$gs_Value = $go_Column->GetValue();
			}
			$go_Limit = new KBLimit( $go_Column->GetName(), NULL, "kbtyp", $gs_Value, $kbtyp );
			break;
		case "resellertrafficcolumn":
			$gs_Value = $go_Column->GetValue();
			if ( $gs_Value > 0 )
				$gs_Value *= 1024;
			$go_Limit = new TrafficLimit ( $go_Column->GetName(), $gs_Value );
			break;
		default:
			$go_Limit = new TextLimit( $go_Column->GetName(), NULL, $go_Column->GetValue() );
	}
	$go_Limits->AppendRow( new HTMLDataField($go_Column->GetLabel()), $go_Limit->GetField(),
			$go_Limit->GetUnlimitedField() );
}
$go_Limits->AppendHidden( new TextDataField( $ident, 'ident' ) );
$go_Limits->AppendHidden( new TextDataField( $gs_NewUser?'nein':$datenausdbholen, 'datenausdbholen' ) );
if ( ! $gs_NewUser ){
	$go_Limits->AppendHidden( new TextDataField( $kunde, 'kunde' ) );
 }

$go_Limits->AppendHidden( new TextDataField( 'next', 'target' ) );

$go_Services = new SetOfRowsData();
for ( ; $go_Column; $go_Column =& $go_User->NextService() ) {
	$go_Services->AppendRow( new HTMLDataField($go_Column->GetLabel()), $go_Column->GetDataField() );
 }



$go_AllData = new MultiSetData();

$go_AllData->AppendData( $go_Limits, ltext("ldf_limits_title") );
$go_AllData->AppendData( $go_Services, ltext("ldf_services_title") );

if( $gs_NewUser ){
	$go_AllData->AppendButton( ltext("kune1_back"), 
														 "javascript:goPrevPage('kunden_neu1.php')",
														 cc_IDBack,
														 array( 'type'=>'reset',
																	  'tabindex' => 1 )
														 );
	$go_AllData->AppendButton( ltext( "kune2_button2" ),
														 "javascript:doChange()",
														 cc_IDNext,
														 array( 'type' => 'submit',
																		'tabindex' => 0 )
														 );
 } elseif ( !$gs_NewUser && strlen($ident) ) {
 	$go_AllData->AppendButton( ltext("kune1_back"),  "javascript:setValue('target','back');".
														 "goPrevPage('kunden_neu1.php')",
														 cc_IDBack, array( 'type'=>'reset', 'tabindex' => 1 )
														 );
 	$go_AllData->AppendButton( ltext( "kune2_button1" ), "javascript:doChange()", cc_IDOk, 'submit');
 
 } else{
	$go_AllData->AppendButton( ltext( "kune2_button1" ),
														 "javascript:doChange()",
														 cc_IDOk,
														 'submit'
														 );

 }

/* -------------------- end initialize form -------------------- */




/* -------------------- output -------------------- */
$go_Page = new MainPageElement( ltext( $gs_NewUser ? "kune2_title3" : "kune2_title2" )."&nbsp;".$kunde,
		$go_AllData->GetInputPresentation( array( "method"=>"post", "action"=>
				( $gs_NewUser ? "kunden_neu3.php" : "kunden_leistungen_upd.php" ) ) ) );
$go_Page->OutputHTML( array( "../../js/common.js",
														 "../../js/paged_form.js") );
/* -------------------- end output -------------------- */
?>
