<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

include_once("auth.php");
include_once( "../include/class.SQLInteger.php" );
include_once( "../include/class.SQLString.php" );
include_once( "../include/class.SQLFieldSet.php" );

global $DEBUG;
//$DEBUG=1;

## mysql verbindung aufbauen
db_connect($db_host, $db_user, $db_pass);
## /mysql verbindung aufbauen

if($DEBUG){
	echo "tools_domains_neu.php: _POST<br><pre>\n";
	print_r($_POST);
	echo "</pre><hr>\n";
}


$timestamp = time();

$prefix = strtolower($prefix);
$domain = strtolower($domain);

$neuedomain = $prefix . "." . $domain;

if(is_int(strpos($neuedomain,'*'))){
	$cssl = 0;
	$cssl_redirect = 0;
 }


## Richtige Eingabe?

$loUser = new SQLString( $PHP_AUTH_USER );
## so viel darf noch eingerichtet werden
$id = safe_query2( "SELECT maxsubdomains, anbieter, wildcard, httpdspezial FROM kunden WHERE kunde = ? ",  $loUser);
$werte = db_fetch_array($id);
$maxsubdomains = $werte["maxsubdomains"];
$anbieter = $werte["anbieter"];
$wildcard = $werte["wildcard"];
$httpdspezial = $werte["httpdspezial"];

$id = safe_query2( "SELECT COUNT(domain) FROM domains WHERE richtigedomain=0 AND kunde = ? ", $loUser );
list($genutztesubdomains) = db_fetch_array( $id );
if ($maxsubdomains != -1) { 
	$freiesubdomains = $maxsubdomains - $genutztesubdomains; 
} else { 
	$freiesubdomains = -1; 
}
## /so viel darf noch eingerichtet werden

## wildcard schon eingerichtet?
if ($wildcard > 0)	{
	$id = safe_query2( "SELECT COUNT(domain) FROM domains WHERE domain LIKE '*.%' AND kunde = ? ", $loUser );
	list($wildcards) = db_fetch_array( $id );
}
##/

if (($freiesubdomains < 1) && ($freiesubdomains != -1))	{
	$fehlertext = ltext("todone_error1");
	db_close();
	include("tools_domains.php");
	exit();
}

if ( ( ( istleer( $prefix ) ) || 
			 ( ereg( "[.-]$",  $prefix ) ) || 
			 ( ereg( "^[.-]", $prefix ) ) || 
			 ( ereg( "[.]{2}", $prefix ) ) || 
			 ( ereg( "[^a-zA-Z0-9.-]", $prefix ))
			 ) && ($prefix != "*") )	{
	$fehlertext = ltext("todone_error2");
	db_close();
	include("tools_domains.php");
	exit();
}

if ( ($prefix == "*") && (($wildcard == 0) || ($wildcards >= $wildcard)) && ($wildcard != -1)){
	$fehlertext = ltext("todone_error3");
	db_close();
	include("tools_domains.php");
	exit();
}


if ( istleer( $domain ) ) {
	$fehlertext = ltext("todone_error4");
	db_close();
	include("tools_domains.php");
	exit();
}

if ( ( ereg( " ", $domain ) ) || ( ereg( " ", $pfad ) ) )	{
	$fehlertext = ltext("todone_error5");
	db_close();
	include("tools_domains.php");
	exit();
}

if (istleer($pfad))	{
	$fehlertext = ltext("todone_error6");
	db_close();
	include("tools_domains.php");
	exit();
}
	
if ( ereg("[\n\t\r]", $pfad) ){
	$fehlertext = ltext("todone_error8");
	db_close();
	include("tools_domains.php");
	 exit();
}
		
if (((!ereg("^/", $pfad)) && (!ereg("^http[s]?://", $pfad))) || (ereg("/\.\.", $pfad)))	{
	$fehlertext = ltext("todone_error7");
	db_close();
	include("tools_domains.php");
	exit();
}

if (((preg_match("/[.]{2}/", $pfad)) || (preg_match("/[^a-zA-Z0-9\.\/~\-\?=&]/", $pfad))) 
			&& (!preg_match("/^http[s]?:\/\//", $pfad)))	
{
	$fehlertext = ltext("todone_error8");
	db_close();
	include("tools_domains.php");
	exit();
}

if (ereg("[\\]", $pfad))	{
	$fehlertext = ltext("todone_error9");
	db_close();
	include("tools_domains.php");
	exit();
}

$loDomain = new SQLString( $domain );
# existiert die domain
$id = safe_query2( "select grp FROM domains WHERE domain = ? AND kunde = ? ",  
									 $loDomain, $loUser );
if (db_num_rows($id) < 1)	{
	$fehlertext = ltext("todone_error10", array($domain));
	db_close();
	include("tools_domains.php");
	exit();
}
list($liGrp) = db_fetch_array($id);
# /existiert die domain?

# sub-domain schon da?
$loNewDomain = new SQLString( $neuedomain );
$id = safe_query2( "SELECT COUNT(domain) FROM domains WHERE domain = ? ", $loNewDomain );
list($count) = db_fetch_array($id);
if ( $count > 0) 	{
	$fehlertext = ltext("todone_error11");
	db_close();
	include("tools_domains.php");
	exit();
}
# /sub-domain schon da?

## //

if ((ereg("/$",$pfad)) && ($pfad != "/") && (ereg("^/", $pfad))) { 
	$pfad = substr($pfad,0,-1); 
}

$loFields = new SQLFieldSet( array( 'domain' => array( $neuedomain, 'C' ),
																		'kunde' => array( $PHP_AUTH_USER, 'C' ),
																		'anbieter' => array( $anbieter, 'C' ),
																		'pfad' => array( $pfad, 'C' ),
																		'richtigedomain' => 0,
																		'zusatz' => array( $httpdspezial, 'C' ),
																		'grp' => $liGrp,
																		'cssl' => ($cssl_redirect? 2: $cssl)
																		)
														 );
list($lcFlds,$lcVals) = $loFields->getSQLInsert();
db_query( "INSERT INTO domains ( $lcFlds ) VALUES ( $lcVals )" );  

## lastchange fr hauptdomain ndern
$timestamp = time();
safe_query2( "UPDATE domains SET lastchange = ? WHERE domain = ?  AND richtigedomain=1 AND kunde = ? ", 
						 new SQLInteger( $timestamp ), $loDomain, $loUser );
## // lastchange fr hauptdomain ndern

domain_aendern( $neuedomain, "anlegen", $PHP_AUTH_USER );
fpalias_aendern( $neuedomain, "anlegen", $PHP_AUTH_USER );

safe_query2( "UPDATE allgemein SET httpd=1" );
safe_query2( "UPDATE kunden SET changedomains=1, httpd=1 WHERE kunde = ? ", $loUser );

set_countdomains( $PHP_AUTH_USER );

$pfad = ""; ##reset fr tools_domain.php
$prefix = "";

$fehlertext = ltext("todone_error12", array($neuedomain));
$fehlertitel = ltext("todone_error13");
db_close();


include("tools_domains.php");

?>
